/*
 * yasapi_config1.c
 * Copyright (C) 2015 Peter Belkner <pbelkner@snafu.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 */
#include <yasapi.h>
#if ! defined (YASAPI_CONFIG2) // {
#include <resources.h>

static INT_PTR CALLBACK ConfigProc(HWND hDlg, UINT uMsg, WPARAM wParam,
    LPARAM lParam)
{
  Options *pOptions=(Options *)GetWindowLongPtr(hDlg,GWLP_USERDATA);

  switch (uMsg) { 
  case WM_INITDIALOG:
    SetWindowLongPtr(hDlg,GWLP_USERDATA,lParam);
    SetWindowTextA(hDlg,PI_LABEL " Settings");
#if ! defined (YASAPI_OPTION_WRITTEN_TIME) // {
    ShowWindow(GetDlgItem(hDlg,IDC_STATIC_LABEL_WRITTENTIME),FALSE);
    ShowWindow(GetDlgItem(hDlg,IDC_CHECKBOX_WRITTENTIME_AUDIO),FALSE);
    ShowWindow(GetDlgItem(hDlg,IDC_CHECKBOX_WRITTENTIME_VIDEO),FALSE);
#endif // }
    ConfigOptionsSetOptions(hDlg,(Options *)lParam);
    break;
  case WM_HSCROLL: 
    ConfigSliderSync(hDlg);
    break;
  case WM_COMMAND: 
    switch (LOWORD(wParam)) { 
    case IDOK: 
      ConfigOptionsGetOptions(hDlg,pOptions);
      EndDialog(hDlg,TRUE); 
      return TRUE;
    case IDCANCEL: 
      EndDialog(hDlg,TRUE); 
      return TRUE;
    case IDC_BUTTON_DEFAULT:
      ConfigOptionsSetOptions(hDlg,NULL);
      return TRUE;
    default: 
      break; 
    } 

    break;
  default: 
    break; 
  } 

  return FALSE; 
}

void ConfigDialog(HWND hWndParent, Options *pOptions)
{
  HMODULE hModule=GetModuleHandleA(YASAPI_MODULE);
  LPCSTR lpTemplateName=MAKEINTRESOURCEA(IDD_CONFIG1);

  DialogBoxParamA(
    hModule,              // _In_opt_  HINSTANCE hInstance,
    lpTemplateName,       // _In_      LPCTSTR lpTemplateName,
    hWndParent,           // _In_opt_  HWND hWndParent,
    ConfigProc,           // _In_opt_  DLGPROC lpDialogFunc,
    (LPARAM)pOptions      // _In_      LPARAM dwInitParam
  );
}
#endif // }
